"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dev = void 0;
const devMiddleware = __importStar(require("webpack-dev-middleware"));
/* eslint-disable no-param-reassign */
function dev(compiler, opts) {
    const middleware = devMiddleware(compiler, opts);
    let nextFlag = false;
    const nextFn = () => {
        nextFlag = true;
    };
    const handler = (ctx, next) => {
        middleware(ctx.req, {
            send: content => (ctx.body = content),
            setHeader: (name, value) => ctx.set(name, value),
            getHeader: name => ctx.get(name),
        }, nextFn);
        if (nextFlag) {
            nextFlag = false;
            return next();
        }
    };
    handler.fileSystem = middleware.fileSystem;
    return handler;
}
exports.dev = dev;
